#include "config.h"
#include "resoff.h"

/*======================================================================
  Function client_cmdchk
  Input : number of arguments and arguments of main function
  Output : option number of reserve, cancel or list
           Return value:
	     -r option : _RESERVE (1)
	     -d option : _CANCEL (2)
	     -l option : _LIST (3)
	     otherwise : 0
  determine option number from user input
======================================================================*/
int client_cmdchk (int argc, char **argv) 
{

    if ( argc < 2 ) {                     /* too small arguments */
        print_usage();
        exit(0);
    }
    else if ( argv[1][0] == '-' && strlen(argv[1]) == 2 ) {  /* -r, -d, -l */
        switch( argv[1][1] ) {
	case 'r' :
	    if ( argc == 5 ) {
                if ( (is_rsv_cmd(argv)) )
                    return (_RESERVE);
            }
	    break;
	case 'd' :
	    if ( argc == 5 || argc == 4 ) { 
                if ( (is_cancel_cmd(argv)) )
                    return (_CANCEL);
            }
	    break;
	case 'l' :
	    if ( argc == 2 ) { return (_LIST); }
	    break;
	default:
	    return (FALSE);
	}
    }

    return (FALSE);
    
}

/*======================================================================
  Function is_rsv_cmd
  Input : arguments of main function
  Output : boolean
  Validity check for reserve request
======================================================================*/
int is_rsv_cmd (char **argv) 
{
    
    if ( !(course_check(argv[4])) && get_db_index(argv) > -1 ) {
        return (TRUE);
    }

    return (FALSE);

}

/*======================================================================
  Function is_cancel_cmd
  Input : arguments of main function
  Output : boolean
  Validity check for cancel request
======================================================================*/
int is_cancel_cmd (char **argv)
{
    
    if ( get_db_index(argv) > -1 )
        return (TRUE);
    
    return (FALSE);
    
}

/*======================================================================
  Function is_all_digit
  Input : a string which needs to be all digit
  Output : boolean
  Validity check for digit string
======================================================================*/
int is_all_digit (char *str)
{
    int len;
    int i;
    
    len = strlen(str);
    
    for (i=0; i<len; i++) {
        if ( !(isdigit( (int)str[i]) ) ) {
            return (FALSE);
        }
    }
    
    return (TRUE);
}

/*======================================================================
  Function make_upper
  Input : string
  Output : string turned to upper case
  make a given string to upper cases
======================================================================*/
void make_upper (char *str) {

    int i;
    int len;

    len = strlen (str);
    for (i=0; i<len; i++) {
        str[i] = toupper(str[i]);
    }

}
