/***********************************************************************
  Client main function of Assignment #5 of Advanced Unix Programming.
  Input : options, days, times, course number, user name (parameters)
          list of current reserved desk database through TCP/IP from
          server, 'resoffd', result of the functions, error codes
  Output : string queries from 'resoffc' clients through TCP/IP
  Assumption : Course number does not check.
               Total reserved blocks by a user does not check.
  Author : Jungkee (Jake) Kim
  Date : November 13, 2000 (Due Date)
************************************************************************/
#include "config.h"
#include "resoff.h"

int main(int argc, char **argv) {

    int option;                       /* kind of options */
    char *server;                     /* server domain name */
    struct hostent *hosts;            /* host information */
    char *strport;                    /* string type of port number */
    int portnumber;                   /* integer type of port number */
    int sockfd;
    struct sockaddr_in servaddr;
   
    option = client_cmdchk(argc, argv);        /* parameter option checking */
    if ( !option ) {
	error_quit('D');
    }
       
    if ( !(server = getenv("RESOFFHOST")) ) {  /* get env. of host name */
        server = "mom.cs.fsu.edu";
    }
    if ( !(hosts = gethostbyname(server)) ) {
        error_quit('6');
    }

    if ( !(strport = getenv("RESOFFPORT")) ) { /* get env. of port number */
        portnumber = SERV_PORT;
    }
    else {                                /* check port number for digits */
        if ( is_all_digit(strport) )
            portnumber = atoi(strport);
        else
            error_quit ('E');
    }
    
    if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0 ){
        error_quit('7');                      /* kind of connection fails */
    }

    memset (&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_port = htons(portnumber);
    servaddr.sin_addr = *(struct in_addr *) (hosts->h_addr_list[0]);
    
    if ( (connect(sockfd, (SA *) &servaddr, sizeof(servaddr))) < 0 ) {
        connerrmsg();
    }
    
    switch( option ) {
    case _RESERVE:
        req_reserve(sockfd, argv);
        break;
    case _CANCEL:
        req_cancel(sockfd, argc, argv);
        break;
    case _LIST:
        req_list(sockfd);
	break;
    default:
        ERR_QUIT("option");                         /* unreachable */
        break;
    }

    exit(NORMAL);
}
