#include "config.h"
#include "resoff.h"

/*======================================================================
  Function req_list
  Input : socket file descriptor
          error code or list string
  Output : error message or
           list of reserved desks
           heading, day, time, user name, course name
  request and print the contents of the database
======================================================================*/
void req_list (int sockfd)
{
    char sendline[2];              /* send string */
    char recvline[MAXLINE];        /* receive string */
    int n;                         /* number of character bytes */
    int count;                     /* number of lines received */
        
    Signal(SIGALRM, sig_alrm);     /* signal set for time out */

    count = 0;

    n = sizeof(sendline);
    snprintf(sendline, n, "l");
        
    if ( (write(sockfd, sendline, n)) != n )
        ERR_QUIT ("writing");

    alarm(MAXWAIT);                 /* wait up to MAXWAIT seconds */
    
    while ( (n = readline(sockfd, recvline, MAXLINE)) > 0) {
        if ( ++count > 5000 ) {                  /* check for limit line */
            error_quit('C');
        }
        recvline[n] = 0;	/* null terminate */
        if (fputs(recvline, stdout) == EOF)
         ERR_QUIT("fputs error");
        printf("\n");                            /* newline inserting */
    }
    
    alarm(0);
    
    if ( n < 0 ) {
        error_quit ('9');
    }
}
