#include "config.h"
#include "resoff.h"

/*======================================================================
  Function get_db_index
  Input : pseudo arguments of main function
  Output : corresponding index of database file
  get a corresoponded index of data block
======================================================================*/
int get_db_index (char **argv) {

    int i, j;
    int index;
    char mwf_day[11][6] = {          /* Monday, Wednesday, Friday time */
        "08:00", "09:05", "10:10", "11:15", "12:20",
	"13:25", "14:30", "15:35", "17:15", "18:45", "20:15" };
    char trsx_day[9][6] = {     /* Tuesday, Thursday, Saturday, Sunday time */
        "08:00", "09:30", "11:00", "12:30",
	"14:00", "15:35", "17:15", "18:45", "20:15" };

    if ( strlen (argv[2]) == 1 && strlen (argv[3]) == 5 ) { /* day and time */
        switch (argv[2][0]) {     /* day argument */
	case 'M':
	    i = 0;
	    break;
	case 'W':
	    i = 1;
	    break;
	case 'F':
	    i = 2;
	    break;
	case 'T':
	    i = 3;
	    break;
	case 'R':
	    i = 4;
	    break;
	case 'S':
	    i = 5;
	    break;
	case 'X':
	    i = 6;
	    break;
	default:
	    /*fprintf (stderr, "day should be one of M, T, W, R, F, S, X\n");*/
	    return (ERROR);
	}

        if ( i < 3 ) {        /* When M or W or F */
	    for (j=0; j<11; j++) {
	        if ( !strcmp (mwf_day[j], argv[3]) ) {
		    index = i * 11 + j;               /* calculate index */
		    return (index);
		}
	    }
	    /*fprintf (stderr, "%s cannot be a time slot of MWF\n", argv[3]);*/
	    return (ERROR);
	}
	else {                /* when T or R or S or X */
	    for (j=0; j<9; j++) {
	        if ( !strcmp (trsx_day[j], argv[3]) ) {
		    index = 33 + ( i - 3 ) * 9 + j;    /* 33 MWF + TRSX */
		    return (index);
		}
	    }
          /*fprintf (stderr, "%s cannot be a time slot of TRSX\n", argv[3]);*/
	    return (ERROR);
	}
    }

    return (ERROR);

}

/*======================================================================
  Function course_check
  Input : char string of course name
  Output : normal or error return
  check validity of course name
======================================================================*/
int course_check (char *course) {

    int len;

    len = strlen (course);
    if ( len != 7 ) {
        /*fprintf(stderr, "Invaild course_number\n");*/
	return (ERROR);
    }
    
    /* is course name llldddd ? (l : letter d : digit) */
    if ( isalpha((int)course[0]) && isalpha((int)course[1]) &&
	 isalpha((int)course[2]) && isdigit((int)course[3]) &&
	 isdigit((int)course[4]) && isdigit((int)course[5]) &&
	 isdigit((int)course[6] )) {
        return (NORMAL);
    }
    else {
        /*fprintf(stderr, "course_number must be formatted as llldddd\n");*/
	return (ERROR);
    }
    
    return (NORMAL);

}
